
"""
This file consists of a number of useful utilis. 
For example, it produce a vector of training points that has exactly n
nonzero coordinates (which is not what we get when we do A =
rand(..)<.5.

Secondly, we provide ways to get training indicies that do not have
any instances of a training relation. 

"""

from pylab import zeros, random, find
def random_train_indicies(len_data, train_size):
    """
def random_train_indicies(len_data, train_size):
return a ranodm boolean vector of length len_data that has
exactly train_size non-False entries.
    """
    assert(len_data > train_size and len_data >=0 and train_size >= 0)

    inds = zeros(len_data).astype(bool) # a boolean array


    # free inds is the list of the remaining indicies
    # (which are free--we're free to set them to 1 in our vector).
    free_inds = range(len_data)

    while sum(inds) != train_size:

        assert(sum(inds) < train_size)
        
        # how many indicies are remaining
        num_remaining_inds = train_size - sum(inds)

        # select a number of the free indicies using randint
        new_free_inds = random.randint(0, len(free_inds), num_remaining_inds)
                                
        for i in new_free_inds:
            inds[free_inds[i]] = True

        free_inds = list(set(free_inds) - set(find(inds)))

    return inds



def train_indicies_without_relation(data, relation_id):
    """
    Given a dataset, return all the indicies that do not contain the
    relation whose id is relation_id.

    (this lets us train MRE on all relations but one, and then test
    its performance on it).
    """
    inds = zeros(len(data)).astype(bool)

    for i, (a, r, b) in enumerate(data):
        if r != relation_id:
            inds[i] = True
        else:
            inds[i] = False

    return inds
